## Version 2.3.0
Released 2024-03-11

* major feature: measurement sweeps
  * the new measurement wizard now supports creating sweeps across single or multiple parameters
  * specifying the sweep for each parameter can either be in number of points (linear or logarithmically spaced) or in step size (linear spacing)
  * data generated by the sweeps get saved into their own subfolder in the raw output directory and include extra sweep information
  * a sweep overview file is also added for easier post-processing
* feature: InsertionLossSweep now supports loading a previously measured insertion loss sweep for a calibrated loss measurement
* feature: Chip manifest loading can now be extended to other formats by simply loading your custom classes as addons
* usability: a new settings window allows adjusting the amount of displayed ToDos and the amount of in-memory measurements - useful for long running experiments
* usability: repeating more than just the last measurement is now possible - LabExT will ask you how many older measurement should be repeated
* usability: chip names can be changed after every measurement (provided no manifest is loaded)
* usability: console logging now highlights warnings/errors with colors
* usability: finished measurement plot now spans whole main window
* usability: search for peak can now save parameters without triggering execution
* under-the-hood: complete rewrite of live-viewer for improved performance - if you have custom live viewer cards written, you will need to adapt to the new API
* under-the-hood: saved raw data files now indent with tabs - saves roughly 30% file size
* under-the-hood: update of dependencies due to safety reasons
* deprecation: LabExT does not support Python 3.8 anymore, please switch to Python 3.9 or 3.10

## Version 2.2.0
Released 2023-03-22

* major feature: complete rewrite of the whole mover part
  * user-friendly step-by-step GUI wizard to setup, configure and calibrate stages for chip-level automation
  * 3D calibration which enables to correct for z-offset due to tilted DUT
  * multiple levels of calibration are supported, allowing to trade-off calibration time with movement precision
  * collision-free, simultaneous movement of multiple chip probes to the correct location on a chip 
  * new, clear API for adding your own motorized stages classes and drivers
* usability: device IDs now support arbitrary strings instead of just positive integers
* bugfix: Fix deprecated method isAlive() in KillableThread
* under-the-hood: update of dependencies due to safety reasons
* under-the-hood: improved reliability of GUI integration tests
* deprecation: LabExT does not support Python 3.7 anymore, please switch to Python 3.8 or 3.9
* governance: improved cite-ability of LabExT by providing .bib and .ris files - if you think LabExT helped you in your work, please consider citing

## Version 2.1.3
Released 2022-05-30

* feature: you can now specify a wait time between consecutive ToDo executions in automatic mode
* usability: The live viewer and the search-for-peak are now available via buttons in the main window
* under-the-hood: all automated testing is now done for Python version 3.7, 3.8, and 3.9 on both, Ubuntu and Windows, operating systems
* under-the-hood: update of dependencies due to safety reasons

## Version 2.1.2
Released 2022-01-19

* feature: live viewer has minimum y-axis span option
* bugfix: sometimes old Keysight PMs reported a stat-calc-error on very low recorded powers, these can safely be ignored
* under-the-hood: refactored the SmarAct 3D Piezo Stage driver class as preparation for complete mover overhaul
* under-the-hood: update of dependencies due to safety reasons

## Version 2.1.1
Released 2021-11-07

* feature: LabExt is now pip installable. Documentation is updated to reflect this.
* community: added GitHub issue and PR templates
* under-the-hood: LabExt is now Python 3.7 and 3.8 compatible. Suggested version is 3.8.

## Version 2.1.0
Released 2021-09-06

* feature: A new live viewer GUI is released. It allows to control multiple lasers and power meter channels at the same time and is easily extensible for live-controlling other instruments.
* feature: New, faster search-for-peak with logged power meter and continuous piezo-stage movement. (Only possible with N7744A power meters.)
* bugfix: Piezo stage speeds were wrongly loaded from old save files. The stage API has all units in microns, and not any more nano-meters. A warning to the user is displayed if speed control is off (i.e. speed 0).
* bugfix: LabExT now starts properly on Linux.

## Version 2.0.2
Released 2021-05-03

* feature: A faster, swept search-for-peak (SfP) algorithm is available. The SfP method can be chosen in the Search-for-Peak window as parameter.
* bugfix: Instrument connections were not closed properly after reading instrument properties provoking some more Error 9s.

## Version 2.0.1
Released 2021-02-22

* usability: A comprehensive browser-based help is now accessible via the F1 key inside LabExT or via the Help menu. Try it out!
* usability: A small tool-tip now explains every measurement in more detail, whenever you need to select a measurement.
* usability: Improved during-runtime performance by caching ad-hoc classes at program startup.
* bugfix: Search for peak can now again be enabled in multi-device scans.
* under-the-hood: Updated dependencies to latest versions.
* under-the-hood: Templates for issues and feature requests are now available on the issue tracker.
* under-the-hood: Added author list and contributing guide as part of new help.

## Version 2.0.0
Released 2021-01-15

* under-the-hood: A long awaited feature has finally made into a release: After long trials, it is now possible to run measurements in standalone scripts w/o GUI. This required a change of how Measurements are interfacing with LabExT and required breaking changes, hence the major version upgrade.
  * All previously coded measurements were translated to the new API and are ready to use.
  * Measurement parameter types are more tightly controlled: you can specify int and float for number types.
* usability: Every measurement now has a documentation string associated which details parameters and recommended lab setup.
